QuantLib: BatesProcess Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.20

Public Member Functions | List of all members
BatesProcess Class Reference
Stochastic processes

Square-root stochastic-volatility Bates process. More...

`#include <ql/processes/batesprocess.hpp>`

Inheritance diagram for BatesProcess:
[legend]

## Public Member Functions
| BatesProcess (const Handle< YieldTermStructure > &riskFreeRate, const Handle< YieldTermStructure > &dividendYield, const Handle< Quote > &s0, Real v0, Real kappa, Real theta, Real sigma, Real rho, Real lambda, Real nu, Real delta, HestonProcess::Discretization d=HestonProcess::FullTruncation)
Size | factors () const
| returns the number of independent factors of the process
Disposable< Array > | drift (Time t, const Array &x) const
| returns the drift part of the equation, i.e., \( \mu(t, \mathrm{x}_t) \)
Disposable< Array > | evolve (Time t0, const Array &x0, Time dt, const Array &dw) const
Real | lambda () const
Real | nu () const
Real | delta () const
Public Member Functions inherited from HestonProcess
| HestonProcess (const Handle< YieldTermStructure > &riskFreeRate, const Handle< YieldTermStructure > &dividendYield, const Handle< Quote > &s0, Real v0, Real kappa, Real theta, Real sigma, Real rho, Discretization d=QuadraticExponentialMartingale)
Size | size () const
| returns the number of dimensions of the stochastic process
Size | factors () const
| returns the number of independent factors of the process
Disposable< Array > | initialValues () const
| returns the initial values of the state variables
Disposable< Array > | drift (Time t, const Array &x) const
| returns the drift part of the equation, i.e., \( \mu(t, \mathrm{x}_t) \)
Disposable< Matrix > | diffusion (Time t, const Array &x) const
| returns the diffusion part of the equation, i.e. \( \sigma(t, \mathrm{x}_t) \)
Disposable< Array > | apply (const Array &x0, const Array &dx) const
Disposable< Array > | evolve (Time t0, const Array &x0, Time dt, const Array &dw) const
Real | v0 () const
Real | rho () const
Real | kappa () const
Real | theta () const
Real | sigma () const
const Handle< Quote > & | s0 () const
const Handle< YieldTermStructure > & | dividendYield () const
const Handle< YieldTermStructure > & | riskFreeRate () const
Time | time (const Date &) const
Real | pdf (Real x, Real v, Time t, Real eps=1e-3) const
Public Member Functions inherited from StochasticProcess
virtual Disposable< Array > | expectation (Time t0, const Array &x0, Time dt) const
virtual Disposable< Matrix > | stdDeviation (Time t0, const Array &x0, Time dt) const
virtual Disposable< Matrix > | covariance (Time t0, const Array &x0, Time dt) const
void | update ()
Public Member Functions inherited from Observer
| Observer (const Observer &)
Observer & | operator= (const Observer &)
std::pair< iterator, bool > | registerWith (const ext::shared_ptr< Observable > &)
void | registerWithObservables (const ext::shared_ptr< Observer > &)
Size | unregisterWith (const ext::shared_ptr< Observable > &)
void | unregisterWithAll ()
virtual void | deepUpdate ()
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()

## Additional Inherited Members
Public Types inherited from HestonProcess
enum | Discretization { PartialTruncation, FullTruncation, Reflection, NonCentralChiSquareVariance, QuadraticExponential, QuadraticExponentialMartingale, BroadieKayaExactSchemeLobatto, BroadieKayaExactSchemeLaguerre, BroadieKayaExactSchemeTrapezoidal }
Public Types inherited from Observer
typedef boost::unordered_set< ext::shared_ptr< Observable > > | set_type
typedef set_type::iterator | iterator
Protected Member Functions inherited from StochasticProcess
| StochasticProcess ()
| StochasticProcess (const ext::shared_ptr< discretization > &)
Protected Attributes inherited from StochasticProcess
ext::shared_ptr< discretization > | discretization_

## Detailed Description

Square-root stochastic-volatility Bates process.

This class describes the square root stochastic volatility process incl jumps governed by

\[ \begin{array}{rcl} dS(t, S) &=& (r-d-\lambda m) S dt +\sqrt{v} S dW_1 + (e^J - 1) S dN \\ dv(t, S) &=& \kappa (\theta - v) dt + \sigma \sqrt{v} dW_2 \\ dW_1 dW_2 &=& \rho dt \\ \omega(J) &=& \frac{1}{\sqrt{2\pi \delta^2}} \exp\left[-\frac{(J-\nu)^2}{2\delta^2}\right] \end{array} \]

Examples
  EquityOption.cpp.

## Member Function Documentation

## ◆ evolve()

Disposable<Array> evolve | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt,
|  | const Array & | dw
| ) |  | const
| virtual

returns the asset value after a time interval \( \Delta t \) according to the given discretization. By default, it returns

\[ E(\mathrm{x}_0,t_0,\Delta t) + S(\mathrm{x}_0,t_0,\Delta t) \cdot \Delta \mathrm{w} \]

where \( E \) is the expectation and \( S \) the standard deviation.

Reimplemented from StochasticProcess.